CREATE PROCEDURE "InsertSalesInvoice" (IN aDateWanted DATE,
                                    IN aCustomersID INTEGER,
                                    IN aTransactionCode VARCHAR, 
                                    IN aCustomerRef VARCHAR, 
                                    IN aSourceRef VARCHAR, 
                                    IN aCustomerComment VARCHAR, 
                                    IN aPrivateComment VARCHAR,
                                    IN aStatusID INTEGER,                                    
                                    IN aCarriageCost DECIMAL,                                    
                                    IN aServiceTypeID INTEGER,  
                                    IN aEnteredInSage BOOLEAN, 
                                    IN aPaymentTypeID INTEGER,
                                    IN aTotalPaid DECIMAL,                                  
                                    OUT aID Integer)                                    
BEGIN
  DECLARE Crsr CURSOR FOR Stmt;
PREPARE Stmt FROM
  ' INSERT INTO SalesInvoices
    (DateWanted,
     CustomersID, 
     TransactionCode,  
     CustomerRef, 
     SourceRef, 
     CustomerComment, 
     PrivateComment,
     StatusID,                                    
     CarriageCost,                                    
     ServiceTypeID,  
     EnteredInSage, 
     PaymentTypeID,
     InternetPricePaid,
     TotalPaid)
    VALUES
    (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)';
OPEN Crsr USING aDateWanted,
                aCustomersID, 
                aTransactionCode,  --webkey
                aCustomerRef,  
                aSourceRef,    
                aCustomerComment, 
                aPrivateComment, --delivery address
                aStatusID,                                    
                aCarriageCost,                                    
                aServiceTypeID,  
                aEnteredInSage, --true
                aPaymentTypeID, --prepaid
                aTotalPaid,
                aTotalPaid;              
CLOSE Crsr;
PREPARE Stmt FROM
 'SELECT ID FROM SalesInvoices WHERE TransactionCode = ''' + aTransactionCode + ''' ';
OPEN Crsr USING aTransactionCode;
FETCH FIRST FROM Crsr('ID') INTO aID;
CLOSE Crsr;
END

